> For clean Markdown of any page, append .md to the page URL. > For a complete documentation index, see https://docs.getunleash.io/api/post-bulk-metrics/llms.txt. > For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.getunleash.io/_mcp/server. # Post Bulk Metrics POST https://edge.unleash-instance.example.com/api/client/metrics/bulk Content-Type: application/json Reference: https://docs.getunleash.io/api/post-bulk-metrics ## Authentication - `Authorization` header (required) — API Key authentication via header ## Request ### Body (application/json) This endpoint expects a BatchMetricsRequestBody. - `applications` (list of ClientApplication, required) - `metrics` (list of ClientMetricsEnv, required) - `impactMetrics` (list of ImpactMetric, optional, nullable) - `seenTokens` (list of string, optional, nullable) ## Response ### 202 Accepted bulk metrics ## Errors ### 403 Forbidden Error Was not allowed to post bulk metrics - `any` ## Types ### ClientApplication - `appName` (string, required) - `interval` (integer, required) - `started` (string, required) - `strategies` (list of string, required) - `platformName` (string, optional, nullable) - `platformVersion` (string, optional, nullable) - `sdkFlavor` (string, optional, nullable) - `sdkFlavorVersion` (string, optional, nullable) - `sdkType` (enum, optional, nullable) - Allowed values: `frontend`, `backend` - `sdkVersion` (string, optional, nullable) - `yggdrasilVersion` (string, optional, nullable) - `connectVia` (list of ConnectVia, optional, nullable) - `connectionId` (string, optional, nullable) - `environment` (string, optional, nullable) - `instanceId` (string, optional, nullable) - `projects` (list of string, optional, nullable) ### ClientMetricsEnv - `appName` (string, required) - `environment` (string, required) - `featureName` (string, required) - `no` (integer, required) - `timestamp` (string, required) - `variants` (map from string to integer, required) - `yes` (integer, required) - `platformName` (string, optional, nullable) - `platformVersion` (string, optional, nullable) - `sdkFlavor` (string, optional, nullable) - `sdkFlavorVersion` (string, optional, nullable) - `sdkType` (enum, optional, nullable) - Allowed values: `frontend`, `backend` - `sdkVersion` (string, optional, nullable) - `yggdrasilVersion` (string, optional, nullable) ### ImpactMetric ### ConnectVia - `appName` (string, required) - `instanceId` (string, required) ### ImpactMetric0 - `help` (string, required) - `name` (string, required) - `samples` (list of NumericMetricSample, required) - `type` (enum, required) - Allowed values: `counter` ### ImpactMetric1 - `help` (string, required) - `name` (string, required) - `samples` (list of NumericMetricSample, required) - `type` (enum, required) - Allowed values: `gauge` ### ImpactMetric2 - `help` (string, required) - `name` (string, required) - `samples` (list of BucketMetricSample, required) - `type` (enum, required) - Allowed values: `histogram` ### NumericMetricSample - `value` (double, required) - `labels` (map from string to string, optional, nullable) ### BucketMetricSample - `buckets` (list of Bucket, required) - `count` (long, required) - `sum` (double, required) - `labels` (map from string to string, optional, nullable) ### Bucket - `count` (long, required) - `le` (double, required) ## Examples **Request** ```json { "applications": [ { "appName": "string", "interval": 1, "started": "2024-01-15T09:30:00Z", "strategies": [ "string" ] } ], "metrics": [ { "appName": "string", "environment": "string", "featureName": "string", "no": 1, "timestamp": "2024-01-15T09:30:00Z", "variants": {}, "yes": 1 } ] } ``` **Response** ```json {} ``` **SDK Code** ```python import requests url = "https://edge.unleash-instance.example.com/api/client/metrics/bulk" payload = { "applications": [ { "appName": "string", "interval": 1, "started": "2024-01-15T09:30:00Z", "strategies": ["string"] } ], "metrics": [ { "appName": "string", "environment": "string", "featureName": "string", "no": 1, "timestamp": "2024-01-15T09:30:00Z", "variants": {}, "yes": 1 } ] } headers = { "Authorization": "", "Content-Type": "application/json" } response = requests.post(url, json=payload, headers=headers) print(response.json()) ``` ```javascript const url = 'https://edge.unleash-instance.example.com/api/client/metrics/bulk'; const options = { method: 'POST', headers: {Authorization: '', 'Content-Type': 'application/json'}, body: '{"applications":[{"appName":"string","interval":1,"started":"2024-01-15T09:30:00Z","strategies":["string"]}],"metrics":[{"appName":"string","environment":"string","featureName":"string","no":1,"timestamp":"2024-01-15T09:30:00Z","variants":{},"yes":1}]}' }; try { const response = await fetch(url, options); const data = await response.json(); console.log(data); } catch (error) { console.error(error); } ``` ```go package main import ( "fmt" "strings" "net/http" "io" ) func main() { url := "https://edge.unleash-instance.example.com/api/client/metrics/bulk" payload := strings.NewReader("{\n \"applications\": [\n {\n \"appName\": \"string\",\n \"interval\": 1,\n \"started\": \"2024-01-15T09:30:00Z\",\n \"strategies\": [\n \"string\"\n ]\n }\n ],\n \"metrics\": [\n {\n \"appName\": \"string\",\n \"environment\": \"string\",\n \"featureName\": \"string\",\n \"no\": 1,\n \"timestamp\": \"2024-01-15T09:30:00Z\",\n \"variants\": {},\n \"yes\": 1\n }\n ]\n}") req, _ := http.NewRequest("POST", url, payload) req.Header.Add("Authorization", "") req.Header.Add("Content-Type", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby require 'uri' require 'net/http' url = URI("https://edge.unleash-instance.example.com/api/client/metrics/bulk") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Post.new(url) request["Authorization"] = '' request["Content-Type"] = 'application/json' request.body = "{\n \"applications\": [\n {\n \"appName\": \"string\",\n \"interval\": 1,\n \"started\": \"2024-01-15T09:30:00Z\",\n \"strategies\": [\n \"string\"\n ]\n }\n ],\n \"metrics\": [\n {\n \"appName\": \"string\",\n \"environment\": \"string\",\n \"featureName\": \"string\",\n \"no\": 1,\n \"timestamp\": \"2024-01-15T09:30:00Z\",\n \"variants\": {},\n \"yes\": 1\n }\n ]\n}" response = http.request(request) puts response.read_body ``` ```java import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.post("https://edge.unleash-instance.example.com/api/client/metrics/bulk") .header("Authorization", "") .header("Content-Type", "application/json") .body("{\n \"applications\": [\n {\n \"appName\": \"string\",\n \"interval\": 1,\n \"started\": \"2024-01-15T09:30:00Z\",\n \"strategies\": [\n \"string\"\n ]\n }\n ],\n \"metrics\": [\n {\n \"appName\": \"string\",\n \"environment\": \"string\",\n \"featureName\": \"string\",\n \"no\": 1,\n \"timestamp\": \"2024-01-15T09:30:00Z\",\n \"variants\": {},\n \"yes\": 1\n }\n ]\n}") .asString(); ``` ```php request('POST', 'https://edge.unleash-instance.example.com/api/client/metrics/bulk', [ 'body' => '{ "applications": [ { "appName": "string", "interval": 1, "started": "2024-01-15T09:30:00Z", "strategies": [ "string" ] } ], "metrics": [ { "appName": "string", "environment": "string", "featureName": "string", "no": 1, "timestamp": "2024-01-15T09:30:00Z", "variants": {}, "yes": 1 } ] }', 'headers' => [ 'Authorization' => '', 'Content-Type' => 'application/json', ], ]); echo $response->getBody(); ``` ```csharp using RestSharp; var client = new RestClient("https://edge.unleash-instance.example.com/api/client/metrics/bulk"); var request = new RestRequest(Method.POST); request.AddHeader("Authorization", ""); request.AddHeader("Content-Type", "application/json"); request.AddParameter("application/json", "{\n \"applications\": [\n {\n \"appName\": \"string\",\n \"interval\": 1,\n \"started\": \"2024-01-15T09:30:00Z\",\n \"strategies\": [\n \"string\"\n ]\n }\n ],\n \"metrics\": [\n {\n \"appName\": \"string\",\n \"environment\": \"string\",\n \"featureName\": \"string\",\n \"no\": 1,\n \"timestamp\": \"2024-01-15T09:30:00Z\",\n \"variants\": {},\n \"yes\": 1\n }\n ]\n}", ParameterType.RequestBody); IRestResponse response = client.Execute(request); ``` ```swift import Foundation let headers = [ "Authorization": "", "Content-Type": "application/json" ] let parameters = [ "applications": [ [ "appName": "string", "interval": 1, "started": "2024-01-15T09:30:00Z", "strategies": ["string"] ] ], "metrics": [ [ "appName": "string", "environment": "string", "featureName": "string", "no": 1, "timestamp": "2024-01-15T09:30:00Z", "variants": [], "yes": 1 ] ] ] as [String : Any] let postData = JSONSerialization.data(withJSONObject: parameters, options: []) let request = NSMutableURLRequest(url: NSURL(string: "https://edge.unleash-instance.example.com/api/client/metrics/bulk")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "POST" request.allHTTPHeaderFields = headers request.httpBody = postData as Data let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error as Any) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume() ```